| Cantera 3.0.0

Loading...
Searching...
No Matches
PDSS.h
Go to the documentation of this file.
1/**
2 * @file PDSS.h
3 * Declarations for the virtual base class PDSS (pressure dependent standard state)
4 * which handles calculations for a single species in a phase
5 * (see @ref pdssthermo and class @link Cantera::PDSS PDSS@endlink).
6 */
7
8// This file is part of Cantera. See License.txt in the top-level directory or
9// at https://cantera.org/license.txt for license and copyright information.
10
11#ifndef CT_PDSS_H
12#define CT_PDSS_H
13#include "cantera/base/ct_defs.h"
14#include "cantera/base/AnyMap.h"
15
16 namespace Cantera
17{
18/**
19 * @defgroup pdssthermo Species Standard-State Thermodynamic Properties
20 *
21 * In this module we describe %Cantera's treatment of pressure dependent
22 * standard states (PDSS) objects. These are objects that calculate the standard
23 * state of a single species that depends on both temperature and pressure.
24 *
25 * To compute the thermodynamic properties of multicomponent solutions, it is
26 * necessary to know something about the thermodynamic properties of the
27 * individual species present in the solution. Exactly what sort of species
28 * properties are required depends on the thermodynamic model for the solution.
29 * For a gaseous solution (that is, a gas mixture), the species properties required
30 * are usually ideal gas properties at the mixture temperature and at a
31 * reference pressure (almost always at 1 bar). For other types of solutions,
32 * however, it may not be possible to isolate the species in a "pure" state. For
33 * example, the thermodynamic properties of, say, Na+ and Cl- in saltwater are
34 * not easily determined from data on the properties of solid NaCl, or solid Na
35 * metal, or chlorine gas. In this case, the solvation in water is fundamental
36 * to the identity of the species, and some other reference state must be used.
37 * One common convention for liquid solutions is to use thermodynamic data for
38 * the solutes in the limit of infinite dilution within the pure solvent;
39 * another convention is to reference all properties to unit molality.
40 *
41 * In defining these standard states for species in a phase, we make the
42 * following definition. A reference state is a standard state of a species in a
43 * phase limited to one particular pressure, the reference pressure. The
44 * reference state specifies the dependence of all thermodynamic functions as a
45 * function of the temperature, in between a minimum temperature and a maximum
46 * temperature. The reference state also specifies the molar volume of the
47 * species as a function of temperature. The molar volume is a thermodynamic
48 * function. A full standard state does the same thing as a reference state, but
49 * specifies the thermodynamics functions at all pressures.
50 *
51 * Class PDSS is the base class for a family of classes that compute properties
52 * of a single species in a phase at its standard states, for a range of
53 * temperatures and pressures. PDSS objects are used by derivatives of the
54 * VPStandardState class. These classes assume that there exists a standard
55 * state for each species in the phase, where the thermodynamic functions are
56 * specified as a function of temperature and pressure. Standard state objects
57 * for each species in the phase are all derived from the PDSS virtual base
58 * class.
59 *
60 * The following classes inherit from PDSS. Each of these classes handles just
61 * one species.
62 *
63 * - PDSS_IdealGas
64 * - standardState model = "IdealGas"
65 * - This model assumes that the species in the phase obeys the ideal gas law
66 * for their pressure dependence. The manager uses a SpeciesThermoInterpType object
67 * to handle the calculation of the reference state. This object adds the
68 * pressure dependencies to the thermo functions.
69 *
70 * - PDSS_ConstVol (deprecated in %Cantera 3.0)
71 * - standardState model = "ConstVol" or "constant_incompressible"
72 * - This model assumes that the species in the phase obeys the constant
73 * partial molar volume pressure dependence. The manager uses a
74 * SpeciesThermoInterpType object to handle the calculation of the reference state.
75 * This object adds the pressure dependencies to these thermo functions.
76 *
77 * - PDSS_SSVol
78 * - standardState model = "temperature_polynomial"
79 * - standardState model = "density_temperature_polynomial"
80 * - This model assumes that the species in the phase obey a fairly general
81 * equation of state, but one that separates out the calculation of the
82 * standard state density and/or volume. Models include a cubic polynomial
83 * in temperature for either the standard state volume or the standard state
84 * density. The manager uses a SpeciesThermoInterpType object to handle the
85 * calculation of the reference state. This object then adds the pressure
86 * dependencies and the volume terms to these thermo functions to complete the
87 * representation.
88 *
89 * - PDSS_Water
90 * - standardState model = "Water"
91 * - This model assumes that Species 0 is assumed to be water, and a real
92 * equation of state is used to model the T, P behavior. Note, the model
93 * assumes that the species is liquid water, and not steam.
94 *
95 * - PDSS_HKFT
96 * - standardState model = "HKFT"
97 * - This model assumes that the species follows the HKFT pressure dependent
98 * equation of state
99 *
100 * Normally the PDSS object is not called directly. Instead the
101 * VPStandardStateTP object manages the calls to the PDSS object for the entire
102 * set of species that comprise a phase.
103 *
104 * The PDSS objects may or may not utilize a SpeciesThermoInterpType reference
105 * state manager class to calculate the reference state thermodynamics functions
106 * in their own calculation. There are some classes, such as PDSS_IdealGas and
107 * PDSS_ConstVol, which utilize the SpeciesThermoInterpType object because the
108 * calculation is very similar to the reference state calculation, while there
109 * are other classes, PDSS_Water and PDSS_HKFT, which don't utilize the
110 * reference state calculation at all, because it wouldn't make sense to. For
111 * example, using the PDSS_Water module, there isn't anything special about the
112 * reference pressure of 1 bar, so the reference state calculation would
113 * represent a duplication of work. Additionally, when evaluating thermodynamic
114 * properties at higher pressures and temperatures, near the critical point,
115 * evaluation of the thermodynamics at a pressure of 1 bar may lead to
116 * situations where the liquid is unstable, that is, beyond the spinodal curve
117 * leading to potentially wrong evaluation results.
118 *
119 * @ingroup thermoprops
120 */
121
122 class SpeciesThermoInterpType;
123 class VPStandardStateTP;
124
125//! Virtual base class for a species with a pressure dependent standard state
126/*!
127 * Virtual base class for calculation of the pressure dependent standard state
128 * for a single species
129 *
130 * Class PDSS is the base class for a family of classes that compute properties
131 * of a set of species in their standard states at a range of temperatures and
132 * pressures. The independent variables for this object are temperature and
133 * pressure. The class may have a reference to a SpeciesThermoInterpType object
134 * which handles the calculation of the reference state temperature behavior of
135 * the species.
136 *
137 * This class is analogous to the SpeciesThermoInterpType class, except that
138 * the standard state inherently incorporates the pressure dependence.
139 *
140 * The class operates on a setState temperature and pressure basis. It only
141 * recalculates the standard state when the setState functions for temperature
142 * and pressure are called.
143 *
144 * @ingroup pdssthermo
145 */
146 class PDSS
147{
148 public:
149 //! @name Constructors
150 //! @{
151
152 //! Default Constructor
153 PDSS() = default;
154
155 // PDSS objects are not copyable or assignable
156 PDSS(const PDSS& b) = delete;
157 PDSS& operator=(const PDSS& b) = delete;
158 virtual ~PDSS() = default;
159
160 //! @}
161 //! @name Molar Thermodynamic Properties of the Species Standard State
162 //! @{
163
164 //! Return the molar enthalpy in units of J kmol-1
165 /*!
166 * @return the species standard state enthalpy in J kmol-1 at the current
167 * temperature and pressure.
168 */
169 virtual double enthalpy_mole() const;
170
171 //! Return the standard state molar enthalpy divided by RT
172 /*!
173 * @return The dimensionless species standard state enthalpy divided at
174 * the current temperature and pressure.
175 */
176 virtual double enthalpy_RT() const;
177
178 //! Return the molar internal Energy in units of J kmol-1
179 /*!
180 * @return The species standard state internal Energy in J kmol-1 at the
181 * current temperature and pressure.
182 */
183 virtual double intEnergy_mole() const;
184
185 //! Return the molar entropy in units of J kmol-1 K-1
186 /*!
187 * @return The species standard state entropy in J kmol-1 K-1 at the
188 * current temperature and pressure.
189 */
190 virtual double entropy_mole() const;
191
192 //! Return the standard state entropy divided by RT
193 /*!
194 * @return The species standard state entropy divided by RT at the current
195 * temperature and pressure.
196 */
197 virtual double entropy_R() const;
198
199 //! Return the molar Gibbs free energy in units of J kmol-1
200 /*!
201 * @return The species standard state Gibbs free energy in J kmol-1 at the
202 * current temperature and pressure.
203 */
204 virtual double gibbs_mole() const;
205
206 //! Return the molar Gibbs free energy divided by RT
207 /*!
208 * @return The species standard state Gibbs free energy divided by RT at
209 * the current temperature and pressure.
210 */
211 virtual double gibbs_RT() const;
212
213 //! Return the molar const pressure heat capacity in units of J kmol-1 K-1
214 /*!
215 * @return The species standard state Cp in J kmol-1 K-1 at the current
216 * temperature and pressure.
217 */
218 virtual double cp_mole() const;
219
220 //! Return the molar const pressure heat capacity divided by RT
221 /*!
222 * @return The species standard state Cp divided by RT at the current
223 * temperature and pressure.
224 */
225 virtual double cp_R() const;
226
227 //! Return the molar const volume heat capacity in units of J kmol-1 K-1
228 /*!
229 * @return The species standard state Cv in J kmol-1 K-1 at the
230 * current temperature and pressure.
231 */
232 virtual double cv_mole() const;
233
234 //! Return the molar volume at standard state
235 /*!
236 * @return The standard state molar volume at the current temperature and
237 * pressure. Units are m**3 kmol-1.
238 */
239 virtual double molarVolume() const;
240
241 //! Return the standard state density at standard state
242 /*!
243 * @return The standard state density at the current temperature and
244 * pressure. units are kg m-3
245 */
246 virtual double density() const;
247
248 //! Get the difference in the standard state enthalpy
249 //! between the current pressure and the reference pressure, p0.
250 //! @deprecated To be removed after %Cantera 3.0
251 virtual double enthalpyDelp_mole() const;
252
253 //! Get the difference in the standard state entropy between
254 //! the current pressure and the reference pressure, p0
255 //! @deprecated To be removed after %Cantera 3.0
256 virtual double entropyDelp_mole() const;
257
258 //! Get the difference in the standard state Gibbs free energy
259 //! between the current pressure and the reference pressure, p0.
260 //! @deprecated To be removed after %Cantera 3.0
261 virtual double gibbsDelp_mole() const;
262
263 //! Get the difference in standard state heat capacity
264 //! between the current pressure and the reference pressure, p0.
265 //! @deprecated To be removed after %Cantera 3.0
266 virtual double cpDelp_mole() const;
267
268 //! @}
269 //! @name Properties of the Reference State of the Species in the Solution
270 //! @{
271
272 //! Return the reference pressure for this phase.
273 double refPressure() const {
274 return m_p0;
275 }
276
277 //! return the minimum temperature
278 double minTemp() const {
279 return m_minTemp;
280 }
281
282 //! return the minimum temperature
283 double maxTemp() const {
284 return m_maxTemp;
285 }
286
287 //! Return the molar Gibbs free energy divided by RT at reference pressure
288 /*!
289 * @return The reference state Gibbs free energy at the current
290 * temperature, divided by RT.
291 */
292 virtual double gibbs_RT_ref() const;
293
294 //! Return the molar enthalpy divided by RT at reference pressure
295 /*!
296 * @return The species reference state enthalpy at the current
297 * temperature, divided by RT.
298 */
299 virtual double enthalpy_RT_ref() const;
300
301 //! Return the molar entropy divided by R at reference pressure
302 /*!
303 * @return The species reference state entropy at the current
304 * temperature, divided by R.
305 */
306 virtual double entropy_R_ref() const;
307
308 //! Return the molar heat capacity divided by R at reference pressure
309 /*!
310 * @return The species reference state heat capacity divided by R at the
311 * current temperature.
312 */
313 virtual double cp_R_ref() const;
314
315 //! Return the molar volume at reference pressure
316 /*!
317 * @return The reference state molar volume. units are m**3 kmol-1.
318 */
319 virtual double molarVolume_ref() const;
320
321 //! @}
322 //! @name Mechanical Equation of State Properties
323 //! @{
324
325 //! Returns the pressure (Pa)
326 virtual double pressure() const;
327
328 //! Sets the pressure in the object
329 /*!
330 * Currently, this sets the pressure in the PDSS object. It is indeterminant
331 * what happens to the owning VPStandardStateTP object.
332 *
333 * @param pres Pressure to be set (Pascal)
334 */
335 virtual void setPressure(double pres);
336
337 //! Return the volumetric thermal expansion coefficient. Units: 1/K.
338 /*!
339 * The thermal expansion coefficient is defined as
340 * @f[
341 * \beta = \frac{1}{v}\left(\frac{\partial v}{\partial T}\right)_P
342 * @f]
343 */
344 virtual double thermalExpansionCoeff() const;
345 //! @}
346
347 //! Set the internal temperature
348 /*!
349 * @param temp Temperature (Kelvin)
350 */
351 virtual void setTemperature(double temp);
352
353 //! Return the current stored temperature
354 virtual double temperature() const;
355
356 //! Set the internal temperature and pressure
357 /*!
358 * @param temp Temperature (Kelvin)
359 * @param pres pressure (Pascals)
360 */
361 virtual void setState_TP(double temp, double pres);
362
363 //! Set the internal temperature and density
364 /*!
365 * @param temp Temperature (Kelvin)
366 * @param rho Density (kg m-3)
367 * @deprecated To be removed after %Cantera 3.0
368 */
369 virtual void setState_TR(double temp, double rho);
370
371 //! critical temperature
372 virtual double critTemperature() const;
373
374 //! critical pressure
375 virtual double critPressure() const;
376
377 //! critical density
378 virtual double critDensity() const;
379
380 //! saturation pressure
381 /*!
382 * @param T Temperature (Kelvin)
383 */
384 virtual double satPressure(double T);
385
386 //! Return the molecular weight of the species
387 //! in units of kg kmol-1
388 double molecularWeight() const;
389
390 //! Set the molecular weight of the species
391 /*!
392 * @param mw Molecular Weight in kg kmol-1
393 */
394 void setMolecularWeight(double mw);
395
396 //! @name Initialization of the Object
397 //! @{
398
399 //! Set the SpeciesThermoInterpType object used to calculate reference
400 //! state properties
401 void setReferenceThermo(shared_ptr<SpeciesThermoInterpType> stit) {
402 m_spthermo = stit;
403 }
404
405 //! Set the parent VPStandardStateTP object of this PDSS object
406 /*!
407 * This information is only used by certain PDSS subclasses
408 * @param phase Pointer to the parent phase
409 * @param k Index of this species in the phase
410 */
411 virtual void setParent(VPStandardStateTP* phase, size_t k) {}
412
413 //! Initialization routine
414 /*!
415 * This is a cascading call, where each level should call the the parent
416 * level.
417 */
418 virtual void initThermo() {}
419
420 //! Set model parameters from an AnyMap phase description, for example from the
421 //! `equation-of-state` field of a species definition.
422 void setParameters(const AnyMap& node) {
423 m_input = node;
424 }
425
426 //! Store the parameters needed to reconstruct a copy of this PDSS object
427 virtual void getParameters(AnyMap& eosNode) const {}
428
429 //! This utility function reports back the type of parameterization and
430 //! all of the parameters for the species, index.
431 /*!
432 * @param kindex Species index (unused)
433 * @param type Integer type of the standard type (unused)
434 * @param c Vector of coefficients used to set the
435 * parameters for the standard state.
436 * @param minTemp output - Minimum temperature
437 * @param maxTemp output - Maximum temperature
438 * @param refPressure output - reference pressure (Pa).
439 * @deprecated To be removed after %Cantera 3.0. Use getParameters() instead.
440 */
441 virtual void reportParams(size_t& kindex, int& type, double* const c,
442 double& minTemp, double& maxTemp,
443 double& refPressure) const;
444
445 //! @}
446
447 protected:
448 //! Current temperature used by the PDSS object
449 mutable double m_temp = -1.0;
450
451 //! State of the system - pressure
452 mutable double m_pres = -1.0;
453
454 //! Reference state pressure of the species.
455 double m_p0 = -1.0;
456
457 //! Minimum temperature
458 double m_minTemp = -1.0;
459
460 //! Maximum temperature
461 double m_maxTemp = 10000.0;
462
463 //! Molecular Weight of the species
464 double m_mw = 0.0;
465
466 //! Input data supplied via setParameters. This may include parameters for
467 //! different phase models, which will be used when initThermo() is called.
468 AnyMap m_input;
469
470 //! Pointer to the species thermodynamic property manager. Not used in all
471 //! PDSS models.
472 shared_ptr<SpeciesThermoInterpType> m_spthermo;
473};
474
475//! Base class for PDSS classes which compute molar properties directly
476 class PDSS_Molar : public virtual PDSS
477{
478 public:
479 double enthalpy_RT() const override;
480 double entropy_R() const override;
481 double gibbs_RT() const override;
482 double cp_R() const override;
483};
484
485//! Base class for PDSS classes which compute nondimensional properties directly
486 class PDSS_Nondimensional : public virtual PDSS
487{
488 public:
489 PDSS_Nondimensional();
490
491 double enthalpy_mole() const override;
492 double entropy_mole() const override;
493 double gibbs_mole() const override;
494 double cp_mole() const override;
495
496 double enthalpy_RT_ref() const override;
497 double entropy_R_ref() const override;
498 double gibbs_RT_ref() const override;
499 double cp_R_ref() const override;
500 double molarVolume_ref() const override;
501 double enthalpy_RT() const override;
502 double entropy_R() const override;
503 double gibbs_RT() const override;
504 double cp_R() const override;
505 double molarVolume() const override;
506 double density() const override;
507
508 protected:
509 double m_h0_RT; //!< Reference state enthalpy divided by RT
510 double m_cp0_R; //!< Reference state heat capacity divided by R
511 double m_s0_R; //!< Reference state entropy divided by R
512 double m_g0_RT; //!< Reference state Gibbs free energy divided by RT
513 double m_V0; //!< Reference state molar volume (m^3/kmol)
514 double m_hss_RT; //!< Standard state enthalpy divided by RT
515 double m_cpss_R; //!< Standard state heat capacity divided by R
516 double m_sss_R; //!< Standard state entropy divided by R
517 double m_gss_RT; //!< Standard state Gibbs free energy divided by RT
518 double m_Vss; //!< Standard State molar volume (m^3/kmol)
519};
520
521}
522
523#endif
AnyMap.h
Cantera::AnyMap
A map of string keys to values whose type can vary at runtime.
Definition AnyMap.h:427
Cantera::PDSS_Molar
Base class for PDSS classes which compute molar properties directly.
Definition PDSS.h:477
Cantera::PDSS_Molar::cp_R
double cp_R() const override
Return the molar const pressure heat capacity divided by RT.
Definition PDSS.cpp:220
Cantera::PDSS_Molar::entropy_R
double entropy_R() const override
Return the standard state entropy divided by RT.
Definition PDSS.cpp:210
Cantera::PDSS_Molar::enthalpy_RT
double enthalpy_RT() const override
Return the standard state molar enthalpy divided by RT.
Definition PDSS.cpp:205
Cantera::PDSS_Molar::gibbs_RT
double gibbs_RT() const override
Return the molar Gibbs free energy divided by RT.
Definition PDSS.cpp:215
Cantera::PDSS_Nondimensional
Base class for PDSS classes which compute nondimensional properties directly.
Definition PDSS.h:487
Cantera::PDSS_Nondimensional::molarVolume
double molarVolume() const override
Return the molar volume at standard state.
Definition PDSS.cpp:306
Cantera::PDSS_Nondimensional::enthalpy_mole
double enthalpy_mole() const override
Return the molar enthalpy in units of J kmol-1.
Definition PDSS.cpp:241
Cantera::PDSS_Nondimensional::m_sss_R
double m_sss_R
Standard state entropy divided by R.
Definition PDSS.h:516
Cantera::PDSS_Nondimensional::gibbs_RT_ref
double gibbs_RT_ref() const override
Return the molar Gibbs free energy divided by RT at reference pressure.
Definition PDSS.cpp:261
Cantera::PDSS_Nondimensional::cp_R
double cp_R() const override
Return the molar const pressure heat capacity divided by RT.
Definition PDSS.cpp:301
Cantera::PDSS_Nondimensional::m_cpss_R
double m_cpss_R
Standard state heat capacity divided by R.
Definition PDSS.h:515
Cantera::PDSS_Nondimensional::entropy_R_ref
double entropy_R_ref() const override
Return the molar entropy divided by R at reference pressure.
Definition PDSS.cpp:271
Cantera::PDSS_Nondimensional::enthalpy_RT_ref
double enthalpy_RT_ref() const override
Return the molar enthalpy divided by RT at reference pressure.
Definition PDSS.cpp:266
Cantera::PDSS_Nondimensional::m_h0_RT
double m_h0_RT
Reference state enthalpy divided by RT.
Definition PDSS.h:509
Cantera::PDSS_Nondimensional::m_g0_RT
double m_g0_RT
Reference state Gibbs free energy divided by RT.
Definition PDSS.h:512
Cantera::PDSS_Nondimensional::m_s0_R
double m_s0_R
Reference state entropy divided by R.
Definition PDSS.h:511
Cantera::PDSS_Nondimensional::entropy_mole
double entropy_mole() const override
Return the molar entropy in units of J kmol-1 K-1.
Definition PDSS.cpp:246
Cantera::PDSS_Nondimensional::m_gss_RT
double m_gss_RT
Standard state Gibbs free energy divided by RT.
Definition PDSS.h:517
Cantera::PDSS_Nondimensional::entropy_R
double entropy_R() const override
Return the standard state entropy divided by RT.
Definition PDSS.cpp:291
Cantera::PDSS_Nondimensional::m_cp0_R
double m_cp0_R
Reference state heat capacity divided by R.
Definition PDSS.h:510
Cantera::PDSS_Nondimensional::cp_mole
double cp_mole() const override
Return the molar const pressure heat capacity in units of J kmol-1 K-1.
Definition PDSS.cpp:256
Cantera::PDSS_Nondimensional::enthalpy_RT
double enthalpy_RT() const override
Return the standard state molar enthalpy divided by RT.
Definition PDSS.cpp:286
Cantera::PDSS_Nondimensional::m_Vss
double m_Vss
Standard State molar volume (m^3/kmol)
Definition PDSS.h:518
Cantera::PDSS_Nondimensional::density
double density() const override
Return the standard state density at standard state.
Definition PDSS.cpp:311
Cantera::PDSS_Nondimensional::gibbs_mole
double gibbs_mole() const override
Return the molar Gibbs free energy in units of J kmol-1.
Definition PDSS.cpp:251
Cantera::PDSS_Nondimensional::m_hss_RT
double m_hss_RT
Standard state enthalpy divided by RT.
Definition PDSS.h:514
Cantera::PDSS_Nondimensional::molarVolume_ref
double molarVolume_ref() const override
Return the molar volume at reference pressure.
Definition PDSS.cpp:281
Cantera::PDSS_Nondimensional::gibbs_RT
double gibbs_RT() const override
Return the molar Gibbs free energy divided by RT.
Definition PDSS.cpp:296
Cantera::PDSS_Nondimensional::m_V0
double m_V0
Reference state molar volume (m^3/kmol)
Definition PDSS.h:513
Cantera::PDSS_Nondimensional::cp_R_ref
double cp_R_ref() const override
Return the molar heat capacity divided by R at reference pressure.
Definition PDSS.cpp:276
Cantera::PDSS
Virtual base class for a species with a pressure dependent standard state.
Definition PDSS.h:147
Cantera::PDSS::satPressure
virtual double satPressure(double T)
saturation pressure
Definition PDSS.cpp:186
Cantera::PDSS::molecularWeight
double molecularWeight() const
Return the molecular weight of the species in units of kg kmol-1.
Definition PDSS.cpp:167
Cantera::PDSS::enthalpyDelp_mole
virtual double enthalpyDelp_mole() const
Get the difference in the standard state enthalpy between the current pressure and the reference pres...
Definition PDSS.cpp:103
Cantera::PDSS::cv_mole
virtual double cv_mole() const
Return the molar const volume heat capacity in units of J kmol-1 K-1.
Definition PDSS.cpp:73
Cantera::PDSS::reportParams
virtual void reportParams(size_t &kindex, int &type, double *const c, double &minTemp, double &maxTemp, double &refPressure) const
This utility function reports back the type of parameterization and all of the parameters for the spe...
Definition PDSS.cpp:191
Cantera::PDSS::setTemperature
virtual void setTemperature(double temp)
Set the internal temperature.
Definition PDSS.cpp:162
Cantera::PDSS::entropy_mole
virtual double entropy_mole() const
Return the molar entropy in units of J kmol-1 K-1.
Definition PDSS.cpp:33
Cantera::PDSS::initThermo
virtual void initThermo()
Initialization routine.
Definition PDSS.h:418
Cantera::PDSS::enthalpy_mole
virtual double enthalpy_mole() const
Return the molar enthalpy in units of J kmol-1.
Definition PDSS.cpp:18
Cantera::PDSS::gibbs_RT
virtual double gibbs_RT() const
Return the molar Gibbs free energy divided by RT.
Definition PDSS.cpp:48
Cantera::PDSS::m_p0
double m_p0
Reference state pressure of the species.
Definition PDSS.h:455
Cantera::PDSS::cp_R_ref
virtual double cp_R_ref() const
Return the molar heat capacity divided by R at reference pressure.
Definition PDSS.cpp:93
Cantera::PDSS::m_temp
double m_temp
Current temperature used by the PDSS object.
Definition PDSS.h:449
Cantera::PDSS::density
virtual double density() const
Return the standard state density at standard state.
Definition PDSS.cpp:68
Cantera::PDSS::pressure
virtual double pressure() const
Returns the pressure (Pa)
Definition PDSS.cpp:127
Cantera::PDSS::gibbsDelp_mole
virtual double gibbsDelp_mole() const
Get the difference in the standard state Gibbs free energy between the current pressure and the refer...
Definition PDSS.cpp:115
Cantera::PDSS::setParameters
void setParameters(const AnyMap &node)
Set model parameters from an AnyMap phase description, for example from the equation-of-state field o...
Definition PDSS.h:422
Cantera::PDSS::minTemp
double minTemp() const
return the minimum temperature
Definition PDSS.h:278
Cantera::PDSS::m_spthermo
shared_ptr< SpeciesThermoInterpType > m_spthermo
Pointer to the species thermodynamic property manager.
Definition PDSS.h:472
Cantera::PDSS::entropyDelp_mole
virtual double entropyDelp_mole() const
Get the difference in the standard state entropy between the current pressure and the reference press...
Definition PDSS.cpp:109
Cantera::PDSS::refPressure
double refPressure() const
Return the reference pressure for this phase.
Definition PDSS.h:273
Cantera::PDSS::PDSS
PDSS()=default
Default Constructor.
Cantera::PDSS::setMolecularWeight
void setMolecularWeight(double mw)
Set the molecular weight of the species.
Definition PDSS.cpp:171
Cantera::PDSS::cp_mole
virtual double cp_mole() const
Return the molar const pressure heat capacity in units of J kmol-1 K-1.
Definition PDSS.cpp:53
Cantera::PDSS::gibbs_mole
virtual double gibbs_mole() const
Return the molar Gibbs free energy in units of J kmol-1.
Definition PDSS.cpp:43
Cantera::PDSS::temperature
virtual double temperature() const
Return the current stored temperature.
Definition PDSS.cpp:157
Cantera::PDSS::entropy_R_ref
virtual double entropy_R_ref() const
Return the molar entropy divided by R at reference pressure.
Definition PDSS.cpp:88
Cantera::PDSS::setState_TR
virtual void setState_TR(double temp, double rho)
Set the internal temperature and density.
Definition PDSS.cpp:181
Cantera::PDSS::m_pres
double m_pres
State of the system - pressure.
Definition PDSS.h:452
Cantera::PDSS::molarVolume_ref
virtual double molarVolume_ref() const
Return the molar volume at reference pressure.
Definition PDSS.cpp:98
Cantera::PDSS::m_maxTemp
double m_maxTemp
Maximum temperature.
Definition PDSS.h:461
Cantera::PDSS::m_minTemp
double m_minTemp
Minimum temperature.
Definition PDSS.h:458
Cantera::PDSS::thermalExpansionCoeff
virtual double thermalExpansionCoeff() const
Return the volumetric thermal expansion coefficient. Units: 1/K.
Definition PDSS.cpp:132
Cantera::PDSS::enthalpy_RT
virtual double enthalpy_RT() const
Return the standard state molar enthalpy divided by RT.
Definition PDSS.cpp:23
Cantera::PDSS::critDensity
virtual double critDensity() const
critical density
Definition PDSS.cpp:147
Cantera::PDSS::enthalpy_RT_ref
virtual double enthalpy_RT_ref() const
Return the molar enthalpy divided by RT at reference pressure.
Definition PDSS.cpp:83
Cantera::PDSS::entropy_R
virtual double entropy_R() const
Return the standard state entropy divided by RT.
Definition PDSS.cpp:38
Cantera::PDSS::critTemperature
virtual double critTemperature() const
critical temperature
Definition PDSS.cpp:137
Cantera::PDSS::setParent
virtual void setParent(VPStandardStateTP *phase, size_t k)
Set the parent VPStandardStateTP object of this PDSS object.
Definition PDSS.h:411
Cantera::PDSS::m_mw
double m_mw
Molecular Weight of the species.
Definition PDSS.h:464
Cantera::PDSS::m_input
AnyMap m_input
Input data supplied via setParameters.
Definition PDSS.h:468
Cantera::PDSS::cp_R
virtual double cp_R() const
Return the molar const pressure heat capacity divided by RT.
Definition PDSS.cpp:58
Cantera::PDSS::setReferenceThermo
void setReferenceThermo(shared_ptr< SpeciesThermoInterpType > stit)
Set the SpeciesThermoInterpType object used to calculate reference state properties.
Definition PDSS.h:401
Cantera::PDSS::molarVolume
virtual double molarVolume() const
Return the molar volume at standard state.
Definition PDSS.cpp:63
Cantera::PDSS::intEnergy_mole
virtual double intEnergy_mole() const
Return the molar internal Energy in units of J kmol-1.
Definition PDSS.cpp:28
Cantera::PDSS::maxTemp
double maxTemp() const
return the minimum temperature
Definition PDSS.h:283
Cantera::PDSS::critPressure
virtual double critPressure() const
critical pressure
Definition PDSS.cpp:142
Cantera::PDSS::cpDelp_mole
virtual double cpDelp_mole() const
Get the difference in standard state heat capacity between the current pressure and the reference pre...
Definition PDSS.cpp:121
Cantera::PDSS::getParameters
virtual void getParameters(AnyMap &eosNode) const
Store the parameters needed to reconstruct a copy of this PDSS object.
Definition PDSS.h:427
Cantera::PDSS::setPressure
virtual void setPressure(double pres)
Sets the pressure in the object.
Definition PDSS.cpp:152
Cantera::PDSS::gibbs_RT_ref
virtual double gibbs_RT_ref() const
Return the molar Gibbs free energy divided by RT at reference pressure.
Definition PDSS.cpp:78
Cantera::PDSS::setState_TP
virtual void setState_TP(double temp, double pres)
Set the internal temperature and pressure.
Definition PDSS.cpp:176
Cantera::VPStandardStateTP
This is a filter class for ThermoPhase that implements some preparatory steps for efficiently handlin...
Definition VPStandardStateTP.h:44
ct_defs.h
This file contains definitions of constants, types and terms that are used in internal routines and a...
Cantera
Namespace for the Cantera kernel.
Definition AnyMap.cpp:564